source: installer/opengnsys_update.sh @ 27c67d9

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since 27c67d9 was 663cd905, checked in by ramon <ramongomez@…>, 8 years ago

#730: Actaulizador no cambiar permisos, usa script checkperms.

git-svn-id: https://opengnsys.es/svn/branches/version1.1@5232 a21b9725-9963-47de-94b9-378ad31fedc9

  • Property mode set to 100755
File size: 34.2 KB
Line 
1#!/bin/bash
2#/**
3#@file    opengnsys_update.sh
4#@brief   Script actualización de OpenGnsys
5#@version 0.9 - basado en opengnsys_installer.sh
6#@author  Ramón Gómez - ETSII Univ. Sevilla
7#@date    2010/01/27
8#@version 1.0 - adaptación a OpenGnSys 1.0
9#@author  Ramón Gómez - ETSII Univ. Sevilla
10#@date    2011/03/02
11#@version 1.0.1 - control de auto actualización del script
12#@author  Ramón Gómez - ETSII Univ. Sevilla
13#@date    2011/05/17
14#@version 1.0.2a - obtiene valor de dirección IP por defecto
15#@author  Ramón Gómez - ETSII Univ. Sevilla
16#@date    2012/01/18
17#@version 1.0.3 - Compatibilidad con Debian y auto configuración de acceso a BD.
18#@author  Ramón Gómez - ETSII Univ. Sevilla
19#@date    2012/03/12
20#@version 1.0.4 - Detector de distribución y compatibilidad con CentOS.
21#@author  Ramón Gómez - ETSII Univ. Sevilla
22#@date    2012/05/04
23#@version 1.0.5 - Actualizar BD en la misma versión, compatibilidad con Fedora (systemd) y configuración de Rsync.
24#@author  Ramón Gómez - ETSII Univ. Sevilla
25#@date    2014/04/03
26#@version 1.0.6 - Redefinir URLs de ficheros de configuración usando HTTPS.
27#@author  Ramón Gómez - ETSII Univ. Sevilla
28#@date    2015/03/12
29#@version 1.1.0 - Instalación de API REST y configuración de zona horaria.
30#@author  Ramón Gómez - ETSII Univ. Sevilla
31#@date    2015/11/09
32#*/
33
34
35####  AVISO: NO EDITAR variables de configuración.
36####  WARNING: DO NOT EDIT configuration variables.
37INSTALL_TARGET=/opt/opengnsys           # Directorio de instalación
38OPENGNSYS_CLIENTUSER="opengnsys"        # Usuario Samba
39
40
41# Sólo ejecutable por usuario root
42if [ "$(whoami)" != 'root' ]; then
43        echo "ERROR: this program must run under root privileges!!"
44        exit 1
45fi
46# Error si OpenGnsys no está instalado (no existe el directorio del proyecto)
47if [ ! -d $INSTALL_TARGET ]; then
48        echo "ERROR: OpenGnsys is not installed, cannot update!!"
49        exit 1
50fi
51# Cargar configuración de acceso a la base de datos.
52if [ -r $INSTALL_TARGET/etc/ogAdmServer.cfg ]; then
53        source $INSTALL_TARGET/etc/ogAdmServer.cfg
54elif [ -r $INSTALL_TARGET/etc/ogAdmAgent.cfg ]; then
55        source $INSTALL_TARGET/etc/ogAdmAgent.cfg
56fi
57OPENGNSYS_DATABASE=${OPENGNSYS_DATABASE:-"$CATALOG"}            # Base de datos
58OPENGNSYS_DBUSER=${OPENGNSYS_DBUSER:-"$USUARIO"}                # Usuario de acceso
59OPENGNSYS_DBPASSWORD=${OPENGNSYS_DBPASSWORD:-"$PASSWORD"}       # Clave del usuario
60if [ -z "$OPENGNSYS_DATABASE" -o -z "$OPENGNSYS_DBUSER" -o -z "$OPENGNSYS_DBPASSWORD" ]; then
61        echo "ERROR: set OPENGNSYS_DATABASE, OPENGNSYS_DBUSER and OPENGNSYS_DBPASSWORD"
62        echo "       variables, and run this script again."
63fi
64
65# Comprobar si se ha descargado el paquete comprimido (USESVN=0) o sólo el instalador (USESVN=1).
66PROGRAMDIR=$(readlink -e $(dirname "$0"))
67PROGRAMNAME=$(basename "$0")
68OPENGNSYS_SERVER="www.opengnsys.es"
69if [ -d "$PROGRAMDIR/../installer" ]; then
70        USESVN=0
71else
72        USESVN=1
73fi
74SVN_URL="http://$OPENGNSYS_SERVER/svn/branches/version1.1/"
75
76WORKDIR=/tmp/opengnsys_update
77mkdir -p $WORKDIR
78
79# Registro de incidencias.
80OGLOGFILE=$INSTALL_TARGET/log/${PROGRAMNAME%.sh}.log
81LOG_FILE=/tmp/$(basename $OGLOGFILE)
82
83
84
85#####################################################################
86####### Algunas funciones útiles de propósito general:
87#####################################################################
88
89# Generar variables de configuración del actualizador
90# Variables globales:
91# - OSDISTRIB - distribución Linux
92# - DEPENDENCIES - array de dependencias que deben estar instaladas
93# - UPDATEPKGLIST, INSTALLPKGS, CHECKPKG - comandos para gestión de paquetes
94# - APACHECFGDIR, APACHESERV, DHCPSERV, INETDCFGDIR - configuración y servicios
95function autoConfigure()
96{
97local i
98
99# Detectar sistema operativo del servidor (compatible con fichero os-release y con LSB).
100if [ -f /etc/os-release ]; then
101        source /etc/os-release
102        OSDISTRIB="$ID"
103        OSVERSION="$VERSION_ID"
104else
105        OSDISTRIB=$(lsb_release -is 2>/dev/null)
106        OSVERSION=$(lsb_release -rs 2>/dev/null)
107fi
108# Convertir distribución a minúsculas y obtener solo el 1er número de versión.
109OSDISTRIB="${OSDISTRIB,,}"
110OSVERSION="${OSVERSION%%.*}"
111
112# Configuración según la distribución de Linux.
113case "$OSDISTRIB" in
114        ubuntu|debian|linuxmint)
115                DEPENDENCIES=( php5-ldap xinetd rsync btrfs-tools procps arp-scan realpath php5-curl gettext moreutils jq )
116                UPDATEPKGLIST="apt-get update"
117                INSTALLPKGS="apt-get -y install --force-yes"
118                CHECKPKG="dpkg -s \$package 2>/dev/null | grep -q \"Status: install ok\""
119                if which service &>/dev/null; then
120                        STARTSERVICE="eval service \$service restart"
121                        STOPSERVICE="eval service \$service stop"
122                else
123                        STARTSERVICE="eval /etc/init.d/\$service restart"
124                        STOPSERVICE="eval /etc/init.d/\$service stop"
125                fi
126                ENABLESERVICE="eval update-rc.d \$service defaults"
127                APACHEUSER="www-data"
128                APACHEGROUP="www-data"
129                INETDCFGDIR=/etc/xinetd.d
130                ;;
131        fedora|centos)
132                DEPENDENCIES=( php-ldap xinetd rsync btrfs-progs procps-ng arp-scan gettext moreutils jq )
133                # En CentOS 7 instalar arp-scan de CentOS 6.
134                [ "$OSDISTRIB$OSVERSION" == "centos7" ] && DEPENDENCIES=( ${DEPENDENCIES[*]/arp-scan/http://dag.wieers.com/redhat/el6/en/$(arch)/dag/RPMS/arp-scan-1.9-1.el6.rf.$(arch).rpm} )
135                INSTALLPKGS="yum install -y"
136                CHECKPKG="rpm -q --quiet \$package"
137                if which systemctl &>/dev/null; then
138                        STARTSERVICE="eval systemctl start \$service.service"
139                        STOPSERVICE="eval systemctl stop \$service.service"
140                        ENABLESERVICE="eval systemctl enable \$service.service"
141                else
142                        STARTSERVICE="eval service \$service start"
143                        STOPSERVICE="eval service \$service stop"
144                        ENABLESERVICE="eval chkconfig \$service on"
145                fi
146                APACHEUSER="apache"
147                APACHEGROUP="apache"
148                INETDCFGDIR=/etc/xinetd.d
149                ;;
150        *)      # Otras distribuciones.
151                ;;
152esac
153for i in apache2 httpd; do
154        [ -d /etc/$i ] && APACHECFGDIR="/etc/$i"
155        [ -f /etc/init.d/$i ] && APACHESERV="/etc/init.d/$i"
156done
157for i in dhcpd dhcpd3-server isc-dhcp-server; do
158        [ -f /etc/init.d/$i ] && DHCPSERV="/etc/init.d/$i"
159done
160}
161
162
163# Comprobar auto-actualización.
164function checkAutoUpdate()
165{
166        local update=0
167
168        # Actaulizar el script si ha cambiado o no existe el original.
169        if [ $USESVN -eq 1 ]; then
170                svn export $SVN_URL/installer/$PROGRAMNAME
171                if ! diff -q $PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME 2>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
172                        mv $PROGRAMNAME $INSTALL_TARGET/lib
173                        update=1
174                else
175                        rm -f $PROGRAMNAME
176                fi
177        else
178                if ! diff -q $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME 2>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
179                        cp -a $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib
180                        update=1
181                fi
182        fi
183
184        return $update
185}
186
187
188function getDateTime()
189{
190        date "+%Y%m%d-%H%M%S"
191}
192
193# Escribe a fichero y muestra por pantalla
194function echoAndLog()
195{
196        echo $1
197        DATETIME=`getDateTime`
198        echo "$DATETIME;$SSH_CLIENT;$1" >> $LOG_FILE
199}
200
201function errorAndLog()
202{
203        echo "ERROR: $1"
204        DATETIME=`getDateTime`
205        echo "$DATETIME;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
206}
207
208# Escribe a fichero y muestra mensaje de aviso
209function warningAndLog()
210{
211        local DATETIME=`getDateTime`
212        echo "Warning: $1"
213        echo "$DATETIME;$SSH_CLIENT;Warning: $1" >> $LOG_FILE
214}
215
216
217#####################################################################
218####### Funciones de copia de seguridad y restauración de ficheros
219#####################################################################
220
221# Hace un backup del fichero pasado por parámetro
222# deja un -last y uno para el día
223function backupFile()
224{
225        if [ $# -ne 1 ]; then
226                errorAndLog "${FUNCNAME}(): invalid number of parameters"
227                exit 1
228        fi
229
230        local fichero=$1
231        local fecha=`date +%Y%m%d`
232
233        if [ ! -f $fichero ]; then
234                warningAndLog "${FUNCNAME}(): file $fichero doesn't exists"
235                return 1
236        fi
237
238        echoAndLog "${FUNCNAME}(): Making $fichero back-up"
239
240        # realiza una copia de la última configuración como last
241        cp -a $fichero "${fichero}-LAST"
242
243        # si para el día no hay backup lo hace, sino no
244        if [ ! -f "${fichero}-${fecha}" ]; then
245                cp -a $fichero "${fichero}-${fecha}"
246        fi
247}
248
249# Restaura un fichero desde su copia de seguridad
250function restoreFile()
251{
252        if [ $# -ne 1 ]; then
253                errorAndLog "${FUNCNAME}(): invalid number of parameters"
254                exit 1
255        fi
256
257        local fichero=$1
258
259        echoAndLog "${FUNCNAME}(): restoring file $fichero"
260        if [ -f "${fichero}-LAST" ]; then
261                cp -a "$fichero-LAST" "$fichero"
262        fi
263}
264
265
266#####################################################################
267####### Funciones de acceso a base de datos
268#####################################################################
269
270# Actualizar la base datos
271function importSqlFile()
272{
273        if [ $# -ne 4 ]; then
274                errorAndLog "${FNCNAME}(): invalid number of parameters"
275                exit 1
276        fi
277
278        local dbuser="$1"
279        local dbpassword="$2"
280        local database="$3"
281        local sqlfile="$4"
282        local tmpfile=$(mktemp)
283        local mycnf=/tmp/.my.cnf.$$
284        local status
285        local APIKEY=$(php -r 'echo md5(uniqid(rand(), true));')
286        REPOKEY=$(php -r 'echo md5(uniqid(rand(), true));')
287
288        if [ ! -r $sqlfile ]; then
289                errorAndLog "${FUNCNAME}(): Unable to read $sqlfile!!"
290                return 1
291        fi
292
293        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
294        chmod 600 $tmpfile
295        sed -e "s/SERVERIP/$SERVERIP/g" -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
296            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
297            -e "s/APIKEY/$APIKEY/g" -e "s/REPOKEY/$REPOKEY/g" $sqlfile > $tmpfile
298        # Componer fichero con credenciales de conexión. 
299        touch $mycnf
300        chmod 600 $mycnf
301        cat << EOT > $mycnf
302[client]
303user=$dbuser
304password=$dbpassword
305EOT
306        # Ejecutar actualización y borrar fichero de credenciales.
307        mysql --defaults-extra-file=$mycnf --default-character-set=utf8 -D "$database" < $tmpfile
308        status=$?
309        rm -f $mycnf $tmpfile
310        if [ $status -ne 0 ]; then
311                errorAndLog "${FUNCNAME}(): error importing $sqlfile in database $database"
312                return 1
313        fi
314        echoAndLog "${FUNCNAME}(): file imported to database $database"
315        return 0
316}
317
318
319#####################################################################
320####### Funciones de instalación de paquetes
321#####################################################################
322
323# Instalar las deependencias necesarias para el actualizador.
324function installDependencies()
325{
326        local package
327
328        if [ $# = 0 ]; then
329                echoAndLog "${FUNCNAME}(): no deps needed."
330        else
331                PHP5VERSION=$(apt-cache pkgnames php5 2>/dev/null | sort | head -1)
332                while [ $# -gt 0 ]; do
333                        package="${1/php5/$PHP5VERSION}"
334                        eval $CHECKPKG || INSTALLDEPS="$INSTALLDEPS $package"
335                        shift
336                done
337                if [ -n "$INSTALLDEPS" ]; then
338                        $UPDATEPKGLIST
339                        $INSTALLPKGS $INSTALLDEPS
340                        if [ $? -ne 0 ]; then
341                                errorAndLog "${FUNCNAME}(): cannot install some dependencies: $INSTALLDEPS."
342                                return 1
343                        fi
344                fi
345        fi
346}
347
348
349#####################################################################
350####### Funciones para el manejo de Subversion
351#####################################################################
352
353function svnExportCode()
354{
355        if [ $# -ne 1 ]; then
356                errorAndLog "${FUNCNAME}(): invalid number of parameters"
357                exit 1
358        fi
359
360        local url="$1"
361
362        echoAndLog "${FUNCNAME}(): downloading subversion code..."
363
364        svn checkout "${url}" opengnsys
365        if [ $? -ne 0 ]; then
366                errorAndLog "${FUNCNAME}(): error getting code from ${url}, verify your user and password"
367                return 1
368        fi
369        echoAndLog "${FUNCNAME}(): subversion code downloaded"
370        return 0
371}
372
373
374############################################################
375###  Detectar red
376############################################################
377
378# Comprobar si existe conexión.
379function checkNetworkConnection()
380{
381        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"www.opengnsys.es"}
382        wget --spider -q $OPENGNSYS_SERVER
383}
384
385# Obtener los parámetros de red del servidor.
386function getNetworkSettings()
387{
388        # Variables globales definidas:
389        # - SERVERIP:   IP local de la interfaz por defecto.
390
391        local DEVICES
392        local dev
393
394        echoAndLog "${FUNCNAME}(): Detecting network parameters."
395        SERVERIP="$ServidorAdm"
396        DEVICES="$(ip -o link show up | awk '!/loopback/ {sub(/:.*/,"",$2); print $2}')"
397        for dev in $DEVICES; do
398                [ -z "$SERVERIP" ] && SERVERIP=$(ip -o addr show dev $dev | awk '$3~/inet$/ {sub (/\/.*/, ""); print ($4)}')
399        done
400}
401
402
403#####################################################################
404####### Funciones específicas de la instalación de Opengnsys
405#####################################################################
406
407# Actualizar cliente OpenGnsys.
408function updateClientFiles()
409{
410        local ENGINECFG=$INSTALL_TARGET/client/etc/engine.cfg
411
412        # Actualizar ficheros del cliente.
413        backupFile $ENGINECFG
414        echoAndLog "${FUNCNAME}(): Updating OpenGnsys Client files."
415        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
416        if [ $? -ne 0 ]; then
417                errorAndLog "${FUNCNAME}(): error while updating client structure"
418                exit 1
419        fi
420        find $INSTALL_TARGET/client -name .svn -type d -exec rm -fr {} \; 2>/dev/null
421
422        # Actualizar librerías del motor de clonación.
423        echoAndLog "${FUNCNAME}(): Updating OpenGnsys Cloning Engine files."
424        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
425        if [ $? -ne 0 ]; then
426                errorAndLog "${FUNCNAME}(): error while updating engine files"
427                exit 1
428        fi
429        # Actualizar fichero de configuración del motor de clonación.
430        if ! grep -q "^TZ" $ENGINECFG; then
431                TZ=$(timedatectl status | awk -F"[:()]" '/Time.*zone/ {print $2}')
432                cat << EOT >> $ENGINECFG
433# OpenGnsys Server timezone.
434TZ="${TZ// /}"
435EOT
436        fi
437        if ! diff -q ${ENGINECFG}{,-LAST} &>/dev/null; then
438                NEWFILES="$NEWFILES $ENGINECFG"
439        else
440                rm -f ${ENGINECFG}-LAST
441        fi
442
443        echoAndLog "${FUNCNAME}(): client files update success."
444}
445
446# Configurar HTTPS y exportar usuario y grupo del servicio Apache.
447function apacheConfiguration ()
448{
449        local config template
450
451        # Activar HTTPS (solo actualizando desde versiones anteriores a 1.0.2) y
452        #    activar módulo Rewrite (solo actualizaciones desde 1.0.x a 1.1.x).
453        if [ -e $APACHECFGDIR/sites-available/opengnsys.conf ]; then
454                echoAndLog "${FUNCNAME}(): Configuring Apache modules."
455                a2ensite default-ssl
456                a2enmod ssl
457                a2enmod rewrite
458                a2ensite opengnsys
459        elif [ -e $APACHECFGDIR/conf.modules.d ]; then
460                echoAndLog "${FUNCNAME}(): Configuring Apache modules."
461                sed -i '/rewrite/s/^#//' $APACHECFGDIR/*.conf
462        fi
463        # Actualizar configuración de Apache a partir de fichero de plantilla.
464        for config in $APACHECFGDIR/{,sites-available/}opengnsys.conf; do
465                # Elegir plantilla según versión de Apache.
466                if [ -n "$(apachectl -v | grep "2\.[0-2]")" ]; then
467                       template=$WORKDIR/opengnsys/server/etc/apache-prev2.4.conf.tmpl > $config
468                else
469                       template=$WORKDIR/opengnsys/server/etc/apache.conf.tmpl
470                fi
471                sed -e "s,CONSOLEDIR,$INSTALL_TARGET/www,g" $template > $config
472        done
473
474        # Reiniciar Apache.
475        $APACHESERV restart
476
477        # Variables de ejecución de Apache.
478        # - APACHE_RUN_USER
479        # - APACHE_RUN_GROUP
480        if [ -f $APACHECFGDIR/envvars ]; then
481                source $APACHECFGDIR/envvars
482        fi
483        APACHE_RUN_USER=${APACHE_RUN_USER:-"$APACHEUSER"}
484        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"$APACHEGROUP"}
485}
486
487# Configurar servicio Rsync.
488function rsyncConfigure()
489{
490        local service
491
492        # Configurar acceso a Rsync.
493        if [ ! -f /etc/rsyncd.conf ]; then
494                echoAndLog "${FUNCNAME}(): Configuring Rsync service."
495                NEWFILES="$NEWFILES /etc/rsyncd.conf"
496                sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENTUSER/g" \
497                    $WORKDIR/opengnsys/repoman/etc/rsyncd.conf.tmpl > /etc/rsyncd.conf
498                # Habilitar Rsync.
499                if [ -f /etc/default/rsync ]; then
500                        perl -pi -e 's/RSYNC_ENABLE=.*/RSYNC_ENABLE=inetd/' /etc/default/rsync
501                fi
502                if [ -f $INETDCFGDIR/rsync ]; then
503                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/rsync
504                else
505                        cat << EOT > $INETDCFGDIR/rsync
506service rsync
507{
508        disable = no
509        socket_type = stream
510        wait = no
511        user = root
512        server = $(which rsync)
513        server_args = --daemon
514        log_on_failure += USERID
515        flags = IPv6
516}
517EOT
518                fi
519                # Activar e iniciar Rsync.
520                service="rsync"  $ENABLESERVICE
521                service="xinetd"
522                $ENABLESERVICE; $STARTSERVICE
523        fi
524}
525
526# Copiar ficheros del OpenGnsys Web Console.
527function updateWebFiles()
528{
529        local ERRCODE COMPATDIR f
530
531        echoAndLog "${FUNCNAME}(): Updating web files..."
532
533        # Copiar los ficheros nuevos conservando el archivo de configuración de acceso.
534        backupFile $INSTALL_TARGET/www/controlacceso.php
535        mv $INSTALL_TARGET/www $INSTALL_TARGET/WebConsole
536        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/WebConsole $INSTALL_TARGET
537        ERRCODE=$?
538        mv $INSTALL_TARGET/WebConsole $INSTALL_TARGET/www
539        unzip -o $WORKDIR/opengnsys/admin/xajax_0.5_standard.zip -d $INSTALL_TARGET/www/xajax
540        unzip -o $WORKDIR/opengnsys/admin/slim-2.6.1.zip -d $INSTALL_TARGET/www/rest
541        unzip -o $WORKDIR/opengnsys/admin/swagger-ui-2.2.5.zip -d $INSTALL_TARGET/www/rest
542        if [ $ERRCODE != 0 ]; then
543                errorAndLog "${FUNCNAME}(): Error updating web files."
544                exit 1
545        fi
546        restoreFile $INSTALL_TARGET/www/controlacceso.php
547
548        # Cambiar acceso a protocolo HTTPS.
549        if grep -q "http://" $INSTALL_TARGET/www/controlacceso.php 2>/dev/null; then
550                echoAndLog "${FUNCNAME}(): updating web access file"
551                perl -pi -e 's!http://!https://!g' $INSTALL_TARGET/www/controlacceso.php
552                NEWFILES="$NEWFILES $INSTALL_TARGET/www/controlacceso.php"
553        fi
554
555        # Compatibilidad con dispositivos móviles.
556        COMPATDIR="$INSTALL_TARGET/www/principal"
557        for f in acciones administracion aula aulas hardwares imagenes menus repositorios softwares; do
558                sed 's/clickcontextualnodo/clicksupnodo/g' $COMPATDIR/$f.php > $COMPATDIR/$f.device.php
559        done
560        cp -a $COMPATDIR/imagenes.device.php $COMPATDIR/imagenes.device4.php
561
562        # Fichero de logs del agente OGAgent.
563        touch $INSTALL_TARGET/log/ogagent.log
564        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/log/ogagent.log
565
566        echoAndLog "${FUNCNAME}(): Web files updated successfully."
567}
568
569# Copiar carpeta de Interface
570function updateInterfaceAdm()
571{
572        local errcode=0
573
574        # Crear carpeta y copiar Interface
575        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
576        mv $INSTALL_TARGET/client/interfaceAdm $INSTALL_TARGET/client/Interface
577        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client
578        errcoce=$?
579        mv $INSTALL_TARGET/client/Interface $INSTALL_TARGET/client/interfaceAdm
580        if [ $errcode -ne 0 ]; then
581                echoAndLog "${FUNCNAME}(): error while updating admin interface"
582                exit 1
583        fi
584        echoAndLog "${FUNCNAME}(): Admin interface updated successfully."
585}
586
587# Crear documentación Doxygen para la consola web.
588function makeDoxygenFiles()
589{
590        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
591        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
592                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
593        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
594                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
595                return 1
596        fi
597        rm -fr "$INSTALL_TARGET/www/api"
598        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
599        rm -fr $INSTALL_TARGET/www/{man,perlmod,rtf}
600        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
601}
602
603
604# Crea la estructura base de la instalación de opengnsys
605function createDirs()
606{
607        # Crear estructura de directorios.
608        echoAndLog "${FUNCNAME}(): creating directory paths in ${INSTALL_TARGET}"
609        local dir
610
611        mkdir -p ${INSTALL_TARGET}/{bin,doc,etc,lib,sbin,www}
612        mkdir -p ${INSTALL_TARGET}/{client,images/group}
613        mkdir -p ${INSTALL_TARGET}/log/clients
614        ln -fs ${INSTALL_TARGET}/log /var/log/opengnsys
615        # Detectar directorio de instalación de TFTP.
616        if [ ! -L ${INSTALL_TARGET}/tftpboot ]; then
617                for dir in /var/lib/tftpboot /srv/tftp; do
618                        [ -d $dir ] && ln -fs $dir ${INSTALL_TARGET}/tftpboot
619                done
620        fi
621        mkdir -p $INSTALL_TARGET/tftpboot/menu.lst/examples
622        if [ $? -ne 0 ]; then
623                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
624                return 1
625        fi
626        ! [ -f $INSTALL_TARGET/tftpboot/menu.lst/templates/00unknown ] && mv $INSTALL_TARGET/tftpboot/menu.lst/templates/* $INSTALL_TARGET/tftpboot/menu.lst/examples
627
628        # Crear usuario ficticio.
629        if id -u $OPENGNSYS_CLIENTUSER &>/dev/null; then
630                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENTUSER\" is already created"
631        else
632                echoAndLog "${FUNCNAME}(): creating OpenGnsys user"
633                useradd $OPENGNSYS_CLIENTUSER 2>/dev/null
634                if [ $? -ne 0 ]; then
635                        errorAndLog "${FUNCNAME}(): error creating OpenGnsys user"
636                        return 1
637                fi
638        fi
639
640        # Mover el fichero de registro al directorio de logs.
641        echoAndLog "${FUNCNAME}(): moving update log file"
642        mv $LOG_FILE $OGLOGFILE && LOG_FILE=$OGLOGFILE
643        chmod 600 $LOG_FILE
644
645        echoAndLog "${FUNCNAME}(): directory paths created"
646        return 0
647}
648
649# Actualización incremental de la BD (versión actaul a actaul+1, hasta final-1 a final).
650function updateDatabase()
651{
652        local OLDVERSION=$(awk '{print $2}' $INSTALL_TARGET/doc/VERSION.txt)
653        local NEWVERSION=$(awk '{print $2}' $WORKDIR/opengnsys/doc/VERSION.txt)
654        local DBDIR="$WORKDIR/opengnsys/admin/Database"
655        local file FILES=""
656
657        echoAndLog "${FUNCNAME}(): looking for database updates"
658        pushd $DBDIR >/dev/null
659        # Bucle de actualización incremental desde versión actual a la final.
660        for file in $OPENGNSYS_DATABASE-*-*.sql; do
661                case "$file" in
662                        $OPENGNSYS_DATABASE-$OLDVERSION-$NEWVERSION.sql)
663                                # Actualización única de versión inicial y final.
664                                FILES="$FILES $file"
665                                break
666                                ;;
667                        $OPENGNSYS_DATABASE-*-postinst.sql)
668                                # Ignorar fichero específico de post-instalación.
669                                ;;
670                        $OPENGNSYS_DATABASE-$OLDVERSION-*.sql)
671                                # Actualización de versión n a n+1.
672                                FILES="$FILES $file"
673                                OLDVERSION="$(echo $file | cut -f3 -d-)"
674                                ;;
675                        $OPENGNSYS_DATABASE-*-$NEWVERSION.sql)
676                                # Última actualización de versión final-1 a final.
677                                if [ -n "$FILES" ]; then
678                                        FILES="$FILES $file"
679                                        break
680                                fi
681                                ;;
682                esac
683        done
684        # Aplicar posible actualización propia para la versión final.
685        file=$OPENGNSYS_DATABASE-$NEWVERSION.sql
686        if [ -n "$FILES" -o "$OLDVERSION" = "$NEWVERSION" -a -r $file ]; then
687                FILES="$FILES $file"
688        fi
689
690        popd >/dev/null
691        if [ -n "$FILES" ]; then
692                for file in $FILES; do
693                        importSqlFile $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD $OPENGNSYS_DATABASE $DBDIR/$file
694                done
695                echoAndLog "${FUNCNAME}(): database is update"
696        else
697                echoAndLog "${FUNCNAME}(): database unchanged"
698        fi
699}
700
701# Copia ficheros de configuración y ejecutables genéricos del servidor.
702function updateServerFiles()
703{
704        # No copiar ficheros del antiguo cliente Initrd
705        local SOURCES=( repoman/bin \
706                        server/bin \
707                        server/lib \
708                        admin/Sources/Services/ogAdmServerAux \
709                        admin/Sources/Services/ogAdmRepoAux \
710                        server/tftpboot \
711                        installer/opengnsys_uninstall.sh \
712                        installer/opengnsys_export.sh \
713                        installer/opengnsys_import.sh \
714                        doc )
715        local TARGETS=( bin \
716                        bin \
717                        lib \
718                        sbin/ogAdmServerAux \
719                        sbin/ogAdmRepoAux \
720                        tftpboot \
721                        lib/opengnsys_uninstall.sh \
722                        lib/opengnsys_export.sh \
723                        lib/opengnsys_import.sh \
724                        doc )
725
726        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
727                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
728                exit 1
729        fi
730
731        echoAndLog "${FUNCNAME}(): updating files in server directories"
732        pushd $WORKDIR/opengnsys >/dev/null
733        local i
734        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
735                if [ -d "$INSTALL_TARGET/${TARGETS[i]}" ]; then
736                        rsync --exclude .svn -irplt "${SOURCES[i]}" $(dirname $(readlink -e "$INSTALL_TARGET/${TARGETS[i]}"))
737                else
738                        rsync -irplt "${SOURCES[i]}" $(readlink -m "$INSTALL_TARGET/${TARGETS[i]}")
739                fi
740        done
741        popd >/dev/null
742        NEWFILES=""             # Ficheros de configuración que han cambiado de formato.
743        if grep -q 'pxelinux.0' /etc/dhcp*/dhcpd*.conf; then
744                echoAndLog "${FUNCNAME}(): updating DHCP files"
745                perl -pi -e 's/pxelinux.0/grldr/' /etc/dhcp*/dhcpd*.conf
746                $DHCPSERV restart
747                NEWFILES="/etc/dhcp*/dhcpd*.conf"
748        fi
749        if ! diff -q $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys 2>/dev/null; then
750                echoAndLog "${FUNCNAME}(): updating new init file"
751                backupFile /etc/init.d/opengnsys
752                cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
753                NEWFILES="$NEWFILES /etc/init.d/opengnsys"
754        fi
755        if egrep -q "(UrlMsg=.*msgbrowser.php)|(UrlMenu=http://)" $INSTALL_TARGET/client/etc/ogAdmClient.cfg 2>/dev/null; then
756                echoAndLog "${FUNCNAME}(): updating new client config file"
757                backupFile $INSTALL_TARGET/client/etc/ogAdmClient.cfg
758                perl -pi -e 's!UrlMsg=.*msgbrowser\.php!UrlMsg=http://localhost/cgi-bin/httpd-log\.sh!g; s!UrlMenu=http://!UrlMenu=https://!g' $INSTALL_TARGET/client/etc/ogAdmClient.cfg
759                NEWFILES="$NEWFILES $INSTALL_TARGET/client/etc/ogAdmClient.cfg"
760        fi
761
762        echoAndLog "${FUNCNAME}(): updating cron files"
763        [ ! -f /etc/cron.d/opengnsys ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/opengnsys.cron ] && $INSTALL_TARGET/bin/opengnsys.cron" > /etc/cron.d/opengnsys
764        [ ! -f /etc/cron.d/torrentcreator ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
765        [ ! -f /etc/cron.d/torrenttracker ] && echo "5 * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-tracker ] && $INSTALL_TARGET/bin/torrent-tracker" > /etc/cron.d/torrenttracker
766        [ ! -f /etc/cron.d/imagedelete ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/deletepreimage ] && $INSTALL_TARGET/bin/deletepreimage" > /etc/cron.d/imagedelete
767        echoAndLog "${FUNCNAME}(): server files updated successfully."
768}
769
770####################################################################
771### Funciones de compilación de código fuente de servicios
772####################################################################
773
774# Mueve el fichero del nuevo servicio si es distinto al del directorio destino.
775function moveNewService()
776{
777        local service
778
779        # Recibe 2 parámetros: fichero origen y directorio destino.
780        [ $# == 2 ] || return 1
781        [ -f  $1 -a -d $2 ] || return 1
782
783        # Comparar los ficheros.
784        if ! diff -q $1 $2/$(basename $1) &>/dev/null; then
785                # Parar los servicios si fuese necesario.
786                [ -z "$NEWSERVICES" ] && service="opengnsys" $STOPSERVICE
787                # Nuevo servicio.
788                NEWSERVICES="$NEWSERVICES $(basename $1)"
789                # Mover el nuevo fichero de servicio
790                mv $1 $2
791        fi
792}
793
794
795# Recompilar y actualiza los serivicios y clientes.
796function compileServices()
797{
798        local hayErrores=0
799
800        # Compilar OpenGnsys Server
801        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Admin Server"
802        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
803        make && moveNewService ogAdmServer $INSTALL_TARGET/sbin
804        if [ $? -ne 0 ]; then
805                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Server"
806                hayErrores=1
807        fi
808        popd
809        # Compilar OpenGnsys Repository Manager
810        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Repository Manager"
811        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo
812        make && moveNewService ogAdmRepo $INSTALL_TARGET/sbin
813        if [ $? -ne 0 ]; then
814                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Repository Manager"
815                hayErrores=1
816        fi
817        popd
818        # Actualizar o insertar clave de acceso REST en el fichero de configuración del repositorio.
819        grep -q '^ApiToken=' $INSTALL_TARGET/etc/ogAdmRepo.cfg && \
820                sed -i "s/^ApiToken=.*$/ApiToken=$REPOKEY/" $INSTALL_TARGET/etc/ogAdmRepo.cfg || \
821                sed -i "$ a\ApiToken=$REPOKEY/" $INSTALL_TARGET/etc/ogAdmRepo.cfg
822        # Compilar OpenGnsys Agent
823        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Agent"
824        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
825        make && moveNewService ogAdmAgent $INSTALL_TARGET/sbin
826        if [ $? -ne 0 ]; then
827                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Agent"
828                hayErrores=1
829        fi
830        popd
831
832        # Compilar OpenGnsys Client
833        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Client"
834        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
835        make && mv ogAdmClient $INSTALL_TARGET/client/bin
836        if [ $? -ne 0 ]; then
837                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Client"
838                hayErrores=1
839        fi
840        popd
841
842        return $hayErrores
843}
844
845
846####################################################################
847### Funciones instalacion cliente OpenGnsys
848####################################################################
849
850# Actualizar cliente OpenGnsys
851function updateClient()
852{
853        PATH=$PATH:$INSTALL_TARGET/bin
854        local DOWNLOADURL=$(oglivecli config download-url)
855        #local FILENAME=ogLive-wily-4.2.0-35-generic-r4919.iso          # 1.1.0-rc3
856        local FILENAME=ogLive-xenial-4.4.0-34-generic-r4999.iso         # 1.1.0-rc4
857        local SOURCEFILE=$DOWNLOADURL/$FILENAME
858        local TARGETFILE=$(oglivecli config download-dir)/$FILENAME
859        local SOURCELENGTH
860        local TARGETLENGTH
861        local OGINITRD
862        local SAMBAPASS
863        local KERNELVERSION
864
865        # Comprobar si debe convertirse el antiguo cliente al nuevo formato ogLive.
866        if oglivecli check | grep -q "oglivecli convert"; then
867                echoAndLog "${FUNCNAME}(): Converting OpenGnsys Client to default ogLive"
868                oglivecli convert
869        fi
870        # Comprobar si debe actualizarse el cliente.
871        SOURCELENGTH=$(LANG=C wget --spider $SOURCEFILE 2>&1 | awk '/Length:/ {print $2}')
872        TARGETLENGTH=$(stat -c "%s" $TARGETFILE 2>/dev/null)
873        [ -z $TARGETLENGTH ] && TARGETLENGTH=0
874        if [ "$SOURCELENGTH" != "$TARGETLENGTH" ]; then
875                echoAndLog "${FUNCNAME}(): Downloading ogLive"
876                oglivecli download $FILENAME
877                if [ ! -s $TARGETFILE ]; then
878                        errorAndLog "${FUNCNAME}(): Error loading OpenGnsys Client"
879                        return 1
880                fi
881                # Actaulizar la imagen ISO del ogclient.
882                echoAndLog "${FUNCNAME}(): Updatting ogLive"
883                oglivecli install $FILENAME
884               
885                # Obtiene versión del Kernel del cliente (con 2 decimales).
886                KERNELVERSION=$(jq -r ".oglive[.default].kernel" |
887                                awk -F. '{printf("%d",$1); $1=""; printf(".%02d",$0)}')
888                # Actaulizar la base de datos adaptada al Kernel del cliente.
889                OPENGNSYS_DBUPDATEFILE="$WORKDIR/opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-postinst.sql"
890                if [ -f $OPENGNSYS_DBUPDATEFILE ]; then
891                        perl -pi -e "s/KERNELVERSION/$KERNELVERSION/g" $OPENGNSYS_DBUPDATEFILE
892                        importSqlFile $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD $OPENGNSYS_DATABASE $OPENGNSYS_DBUPDATEFILE
893                fi
894                CLIENTUPDATED=${FILENAME%.*}
895
896                echoAndLog "${FUNCNAME}(): Client update successfully"
897        else
898                # Si no existe, crear el fichero de claves de Rsync.
899                if [ ! -f /etc/rsyncd.secrets ]; then
900                        echoAndLog "${FUNCNAME}(): Restoring client access key"
901                        OGINITRD=$(oglivecli config install-dir)/$(jq -r ".oglive[.default].directory")/oginitrd.img
902                        SAMBAPASS=$(gzip -dc $OGINITRD | \
903                                    cpio -i --to-stdout scripts/ogfunctions 2>&1 | \
904                                    grep "^[    ].*OPTIONS=" | \
905                                    sed 's/\(.*\)pass=\(\w*\)\(.*\)/\2/')
906                        echo -ne "$SAMBAPASS\n$SAMBAPASS\n" | setsmbpass
907                else
908                        echoAndLog "${FUNCNAME}(): Client is already updated"
909                fi
910                # Versión del ogLive instalado.
911                echo "${FILENAME%.*}" > $INSTALL_TARGET/doc/veroglive.txt
912        fi
913}
914
915# Comprobar permisos y ficheros.
916function checkFiles()
917{
918        # Comprobar permisos adecuados.
919        if [ -x $INSTALL_TARGET/bin/checkperms ]; then
920                echoAndLog "${FUNCNAME}(): Checking permissions."
921                OPENGNSYS_DIR="$INSTALL_TARGET" OPENGNSYS_USER="$OPENGNSYS_CLIENTUSER" APACHE_USER="$APACHE_RUN_USER" APACHE_GROUP="$APACHE_RUN_GROUP" $INSTALL_TARGET/bin/checkperms
922        fi
923
924        # Eliminamos el fichero de estado del tracker porque es incompatible entre los distintos paquetes
925        if [ -f /tmp/dstate ]; then
926                echoAndLog "${FUNCNAME}(): Delete unused files."
927                rm -f /tmp/dstate
928        fi
929}
930
931# Resumen de actualización.
932function updateSummary()
933{
934        # Actualizar fichero de versión y revisión.
935        local VERSIONFILE="$INSTALL_TARGET/doc/VERSION.txt"
936        local REVISION=$(LANG=C svn info $SVN_URL|awk '/Rev:/ {print "r"$4}')
937
938        [ -f $VERSIONFILE ] || echo "OpenGnsys" >$VERSIONFILE
939        perl -pi -e "s/($| r[0-9]*)/ $REVISION/" $VERSIONFILE
940
941        echo
942        echoAndLog "OpenGnsys Update Summary"
943        echo       "========================"
944        echoAndLog "Project version:                  $(cat $VERSIONFILE)"
945        echoAndLog "Update log file:                  $LOG_FILE"
946        if [ -n "$NEWFILES" ]; then
947                echoAndLog "Check new config files:           $(echo $NEWFILES)"
948        fi
949        if [ -n "$NEWSERVICES" ]; then
950                echoAndLog "New compiled services:            $(echo $NEWSERVICES)"
951                # Indicar si se debe reiniciar servicios manualmente o usando el Cron.
952                [ -f /etc/default/opengnsys ] && source /etc/default/opengnsys
953                if [ "$RUN_CRONJOB" == "no" ]; then
954                        echoAndLog "        WARNING: you must restart OpenGnsys services manually."
955                else
956                        echoAndLog "        New OpenGnsys services will be restarted by the cronjob."
957                fi
958        fi
959        echoAndLog "Warnings:"
960        echoAndLog " - You must to clear web browser cache before loading OpenGnSys page."
961        if [ -n "$CLIENTUPDATED" ]; then
962                echoAndLog " - ogLive Client is updated to: $CLIENTUPDATED"
963        fi
964        echo
965}
966
967
968
969#####################################################################
970####### Proceso de actualización de OpenGnsys
971#####################################################################
972
973
974echoAndLog "OpenGnsys update begins at $(date)"
975
976pushd $WORKDIR
977
978# Comprobar si hay conexión y detectar parámetros de red por defecto.
979checkNetworkConnection
980if [ $? -ne 0 ]; then
981        errorAndLog "Error connecting to server. Causes:"
982        errorAndLog " - Network is unreachable, review devices parameters."
983        errorAndLog " - You are inside a private network, configure the proxy service."
984        errorAndLog " - Server is temporally down, try agian later."
985        exit 1
986fi
987getNetworkSettings
988
989# Comprobar auto-actualización del programa.
990if [ "$PROGRAMDIR" != "$INSTALL_TARGET/bin" ]; then
991        checkAutoUpdate
992        if [ $? -ne 0 ]; then
993                echoAndLog "OpenGnsys updater has been overwritten."
994                echoAndLog "Please, re-execute this script."
995                exit
996        fi
997fi
998
999# Detectar datos de auto-configuración del instalador.
1000autoConfigure
1001
1002# Instalar dependencias.
1003installDependencies ${DEPENDENCIES[*]}
1004if [ $? -ne 0 ]; then
1005        errorAndLog "Error: you may install all needed dependencies."
1006        exit 1
1007fi
1008
1009# Arbol de directorios de OpenGnsys.
1010createDirs ${INSTALL_TARGET}
1011if [ $? -ne 0 ]; then
1012        errorAndLog "Error while creating directory paths!"
1013        exit 1
1014fi
1015
1016# Si es necesario, descarga el repositorio de código en directorio temporal
1017if [ $USESVN -eq 1 ]; then
1018        svnExportCode $SVN_URL
1019        if [ $? -ne 0 ]; then
1020                errorAndLog "Error while getting code from svn"
1021                exit 1
1022        fi
1023else
1024        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
1025fi
1026
1027# Actualizar la BD.
1028updateDatabase
1029
1030# Actualizar ficheros complementarios del servidor
1031updateServerFiles
1032if [ $? -ne 0 ]; then
1033        errorAndLog "Error updating OpenGnsys Server files"
1034        exit 1
1035fi
1036
1037# Configurar Rsync.
1038rsyncConfigure
1039
1040# Actualizar ficheros del cliente
1041updateClientFiles
1042updateInterfaceAdm
1043
1044# Actualizar páqinas web
1045apacheConfiguration
1046updateWebFiles
1047if [ $? -ne 0 ]; then
1048        errorAndLog "Error updating OpenGnsys Web Admin files"
1049        exit 1
1050fi
1051# Generar páginas Doxygen para instalar en el web
1052makeDoxygenFiles
1053
1054# Recompilar y actualizar los servicios del sistema
1055compileServices
1056
1057# Actaulizar ficheros auxiliares del cliente
1058updateClient
1059if [ $? -ne 0 ]; then
1060        errorAndLog "Error updating clients"
1061        exit 1
1062fi
1063
1064# Comprobar permisos y ficheros.
1065checkFiles
1066
1067# Mostrar resumen de actualización.
1068updateSummary
1069
1070#rm -rf $WORKDIR
1071echoAndLog "OpenGnsys update finished at $(date)"
1072
1073popd
1074
Note: See TracBrowser for help on using the repository browser.